<script setup>
import {provide, ref, watch} from "vue";
import { Head, useForm } from '@inertiajs/vue3';
import GuestLayout from '@/Layouts/GuestLayout.vue';
import Navigation from "@/Components/Items/Lots/navigation.vue";
import GameLot from "@/Components/Items/Lots/GameLot.vue";
import Select from "@/Components/UI/Select.vue";
import axios from "axios";
import FeatureIcon from "@/Components/Sliders/FeatureIcon.vue";
import FeatureText from "@/Components/Sliders/FeatureText.vue";
import FeatureNumbers from "@/Components/Sliders/FeatureNumbers.vue";
import FeatureColors from "@/Components/Sliders/FeatureColors.vue";
import FeatureOptions from "@/Components/Sliders/FeatureOptions.vue";
import _ from "lodash";

const props = defineProps({
    product:Object,
    games:Object,
    game:Object,
    category:Object,
    categories:Object,
    item:Object,
    features_icon:Object,
    features_text:Object,
    features_number:Object,
    features_color:Object,
    qtu:Number,
    price:Number,
    min_price:Number,
});

const form = useForm({
    game: props.game,
    category:props.category,
    item:props.item.data,
    features_icon:props.features_icon.data,
    features_text:props.features_text,
    features_number:props.features_number,
    features_color:props.features_color,
    qtu:props.qtu,
    price:props.price,
    min_price:props.min_price,
})
const setFeatureNumber = () => {
    if(form.item && form.item?.length){
        form.features_number = _.flattenDeep(form.item.numberFeatures);
        _.forEach(form.features_number, (features_number) => {
            features_number.value = null;
            features_number.check = false;
            if(props.features_number.length){
                let elem = _.find(props.features_number, (i) => i.id === features_number.id);
                if(elem !== undefined){
                    features_number.value = elem.value;
                    features_number.check = true;
                }
            }
        });
    }
}

const submit = () => {
    form.post(route('dashboard.lots.update',{product:props.product.id}), {
        preserveScroll: true
    });
}

const getCategories = () => {
    if(form.category && form.game){
        axios.get('/dashboard/lots/products/items/category/game',{
            params:{
                game:form.game.id,
                category:form.category.id,
            }
        }).then(function (response) {
            items.value = response.data;
        })
    }
}
// const setFeatureText = () => form.features_text = form.item.textFeatures

if(props.item){
    getCategories();
    setFeatureNumber();
    // setFeatureText();
}

const items = ref([]);

watch(
    () => form.game,
    () => {
        form.category = null
        form.item = null
        form.qtu = null
        form.price = null
        form.min_price = null
        form.features_icon = []
        form.features_text = []
        form.features_number = []
        form.features_color = null
    }
)

watch(
    () => form.category,
    () => {
        getCategories();
    }
)

watch(
    () => form.item,
    (val) => {

        setFeatureNumber();
        if(val){
            setFeatureText();
        }

    }
)

provide('form', form)
provide('props',props)
</script>

<template>
    <GuestLayout>
        <Head :title="title" />
        <Navigation/>
        <section class="addLot">
            <div class="container">
                <div class="addLot__inner">
                    <p class="addLot__title">{{ title }}</p>
                    <p class="addLot__subtitle">Пожалуйста заполните все поля</p>
                    <form @submit.prevent="submit" class="addLot__box">
                        <div class="addLot__miniTitle-wrapper">
                            <p class="addLot__miniTitle big">{{ form.game ? form.game?.name : 'Выберите игру'  }}</p>
                        </div>

                        <GameLot/>

                        <Select v-if="form.game"
                                placeholder="Выберете категорию"
                                :options="categories"
                                v-model="form.category"
                        />

                        <Select v-if="form.category"
                                placeholder="Выберете предмет"
                                :options="items"
                                v-model="form.item"
                                :nothing="true"
                        />

                        <template v-if="form.item">

                            <FeatureIcon v-if="form.item.iconFeatures.length"/>

                            <FeatureText v-model="form.features_text"
                                         v-if="form.item.textFeatures.length" />

                            <FeatureNumbers v-if="form.item.numberFeatures.length"/>

                            <FeatureColors v-if="form.item.colorFeatures.length"/>

                            <FeatureOptions/>

                        </template>


                        <div class="addLot__button-wrapper">
                            <button :disabled="form.processing" type="submit" class="addLot__button button effect">Изменить</button>
                        </div>

                    </form>
                </div>
            </div>
        </section>
    </GuestLayout>
</template>



